# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp import models, fields, tools, api, _

class ruc_documentos_timbrados(models.Model):
    _name = 'ruc.documentos.timbrados'
    _description = 'Agrega datos sobre timbrado'

    name = fields.Char('Número de timbrado')
    nombre_documento = fields.Char('Descripción del documento')
    tipo_documento = fields.Selection([('1','Factura'),('2','Factura electrónica de exportación'),('3','Factura electrónica de importación')],'Tipo documento')
    timbrado_electronico = fields.Selection([('1','Factura electrónica'),('2','Factura electrónica de exportación'),('3','Factura electrónica de importación'),('4','Autofactura electrónica'),('5','Nota de crédito electrónica'),('6','Nota de débito electrónica'),('7','Nota de remisión electrónica'),('8','Comprobante de retención electrónico')],'Tipo de documento electrónico')
    actividad_economica = fields.Char('Actividad económica')
    codigo_actividad = fields.Char('Código de actividad económica')
    fecha_inicio = fields.Date(string='Fecha inicio de validez')
    fecha_final = fields.Date(string='Fecha de expiración de timbrado')
    activo = fields.Boolean(string='Activo' ,default = True)
    suc = fields.Char('Suc')
    sec = fields.Char('Sec')
    nro_ini = fields.Integer('Nº inicial')
    nro_fin = fields.Integer('Nº final')
    ultimo_nro_utilizado = fields.Integer('Nro actual')
    id = fields.Integer('ID')
    company_id = fields.Many2one('res.company', string='Compañia')
    company_name =  fields.Char(string='Compañia', related='company_id.name', readonly=True)
    invoice_ids = fields.One2many('account.invoice', 'partner_id', string='Facturas',
        readonly=True, copy=False)
    user_ids = fields.Many2many('res.users', string='Usuarios')
